The stock price analysis part is divided into four parts: [Data Preparation](flow_zone:zzyxx42), [PCA Construction](flow_zone:mPHaLGm), [Stock Clustering](flow_zone:lKLiJca), [Anomaly Detection](flow_zone:5sULb43).
 
 ![Data Preparation.png](JDvh2pgjdnDM)
 
In the data preparation, the stock prices are processed to compute the log returns.
 
![PCA Construction.png](Ph5eWazz8E3I)
 
In the PCA Construction, a python recipe takes the data with the log returns, computes the covariance matrix and then runs the Principal Components Analysis. The output is the coordinates on the first four Principal Components for each stock [computed_PCA_coordinates](dataset:computed_PCA_coordinates).
 
![Stock Clustering.png](7N6SeOFFVnzR)
 
Then, using the PCA coordinates a clustering is run on the stocks. The K-means algorithm is chosen for its simplicity. We choose to retain the model with 8 clusters. Other algorithms could be tried to build subgroups using for example sectors. And the current clusters could be compared and analyzed in more depth to understand how stocks are being regrouped.
 
![Anomaly Detection.png](mRIozrJ4634g)
 
The initial log return dataset is partitioned using the clusters that have been defined above. The anomaly detection will be run on each partition independently. The approach followed is described in more detail in [this article](article:12). The Mahalanobis Distance computations are run in a python recipe. The anomaly labelled is defined with a predefined threshold and an [anomalies](dataset:anomalies) dataset is created that compiles all the anomalies detected with this algorithm.
 